(uiop:define-package :fwoar.zipfile
  (:mix :cl :fwoar.lisputils)
  (:export ))
(in-package :fwoar.zipfile)

(defun read-bytes (n s)
  (with (seq (make-array n :element-type 'serapeum:octet))
    (values seq
            (read-sequence seq s))))

(defun calculate-sizes (desc)
  (reduce #'+ desc
          :key #'cadr
          :initial-value 0))

(defun extract-bytes (desc bytes)
  (loop
     with cur-idx = 0
     for (name size) in desc
     append (list name
                  (subseq bytes cur-idx
                          (+ cur-idx size)))
     do (incf cur-idx size)))

(defun parse-struct (desc s)
  (let* ((struct-size (calculate-sizes desc))
         (bytes (read-bytes struct-size s)))
    (extract-bytes desc bytes)))

(defun make-zipfile-stream (fn)
  (open fn :element-type '(unsigned-byte 8)))
